﻿using Kesion.BLL;
using Kesion.Publics;
using System;
using System.Data;

namespace ReplaceFieldType
{

    /// <summary>
    /// 一键将数据库所有字段为 text、ntext更改为 varchar(MAX)、nvarchar(MAX)
    /// </summary>
    public partial class Run: System.Web.UI.Page
    {


        /// <summary>
        /// 修改字段
        /// </summary>
        /// <param name="TableName"></param>
        /// <param name="ColumnName"></param>
        /// <param name="ColumnType"></param>
        public void ModColumn(string TableName, string ColumnName, string ColumnType)
        {
            try
            {
                DataFactory.ExecuteNonQuery(string.Format("Alter Table {0} Alter Column {1} {2}", TableName, ColumnName, ColumnType));
                KSCMS.W("更改 " + TableName + " 表中字段 " + ColumnName + "类型为"+ ColumnType+" 成功；<br/>");
             
            }
            catch (Exception ex)
            {
                KSCMS.W("更改 " + TableName + " 表中字段属性<font color='blue'>错误</font>，请手动将数据库中 <B>" + ColumnName + "</B> 字段更改为 <B>" + ColumnType + "</B> 属性，原因" + ex.Message+"<br/>");
            }
        }
        protected void Page_Load(object sender, EventArgs e)
        {


            using (DataTable dt = LabelSource.getAllTable(0, string.Empty))
            {

                int num = 0;
                DataView dv = dt.DefaultView;
                dv.RowFilter = "TABLE_NAME like 'ks_%'";

                DataTable dttable = new DataTable();
                dttable.Columns.Add(new DataColumn("Title", typeof(string)));
                dttable.Columns.Add(new DataColumn("TableName", typeof(string)));
                dttable.Columns.Add(new DataColumn("num", typeof(int)));

                KSCMS.W("<h2 align='center' style='margin:30px;'>批量修改数据库表字段text,ntext类型为：varchar(max),nvarchar(max)</h2><div style='border: 1px solid #f2ece3; border-radius: 5px; margin:0 auto; width:70%; padding:12px 15px; text-align: left; font-size: 12px; word-break: break-all; overflow:hidden; background:#fffcef; line-height:22px;'>");
                foreach (DataRow dr in dv.ToTable().Rows)
                {

                    string tableName = dr["TABLE_NAME"].ToString();
                    if (Utils.InArray(tableName, "KS_SearchView,KS_CosBundleSaleGoodsView", ",") == false)
                    {
                        using (DataTable dtfield = LabelSource.getTableFiled(0, string.Empty, tableName))
                        {
                            if (dtfield.Rows.Count > 0)
                            {
                                foreach (DataRow drfield in dtfield.Rows)
                                {
                                    if (drfield["DATA_TYPE"].ToString().ToLower() == "text")
                                    {
                                        num++;
                                        ModColumn(tableName, drfield["COLUMN_NAME"].ToString(), "varchar(MAX)");
                                    }
                                    else if (drfield["DATA_TYPE"].ToString().ToLower() == "ntext")
                                    {
                                        num++;
                                        ModColumn(tableName, drfield["COLUMN_NAME"].ToString(), "nvarchar(MAX)");
                                    }
                                }
                            }
                        }


                        KSCMS.Flush();
                    }


                }

                KSCMS.W("</div>");
                if (num > 0)
                {
                    KSCMS.W($"<h2 align='center' style='color:green'>恭喜，批量成功修改了个{ num }字段！！！</h2>");
                }
                else
                {
                    KSCMS.W($"<h2 align='center' style='color:red'>没有找到 text及ntext类型的字段，无需修改！！！</h2>");
                }
            }

            KSCMS.Die();

         

        }

    }
}